﻿using System;
using System.Collections.Generic;
using System.Text;

using System.Data;
using System.Xml;
using System.Text.RegularExpressions;

namespace ConvertTables
{
    class Convert2 // Source: "http://www.dotnetfunda.com/articles/article51.aspx"
    {
        public String GetHTML()
        {
            StringBuilder sb = new StringBuilder();

            sb.AppendLine("<!DOCTYPE HTML PUBLIC " +
                "-//W3C//DTD HTML 4.01 Transitional//EN" +
                "http://www.w3.org/TR/html4/loose.dtd" +
                ">");
            sb.AppendLine("<html>");
            sb.AppendLine("<head>");
            sb.AppendLine("<meta http-equiv=" +
                "Content-Type" +
                " content=" +
                "text/html; charset=iso-8859-1" +
                "> ");

            // Первая таблица (с заголовком)
            sb.AppendLine("<title>Title</title>");
            sb.AppendLine("</head>");
            sb.AppendLine("<body>");
            sb.AppendLine("<table>");
            sb.AppendLine("<tr>");
            sb.AppendLine("<th>Table 1 - Header 1</th>");
            sb.AppendLine("<th>Table 1 - Header 2</th>");
            sb.AppendLine("<th>Table 1 - Header 3</th>");
            sb.AppendLine("</tr>");
            sb.AppendLine("<tr>");
            sb.AppendLine("<td>Table 1 - Row 1 - Column 1</td>");
            sb.AppendLine("<td>Table 1 - Row 1 - Column 2</td>");
            sb.AppendLine("<td>Table 1 - Row 1 - Column 3</td>");
            sb.AppendLine("</tr>");
            sb.AppendLine("<tr>");
            sb.AppendLine("<td>Table 1 - Row 2 - Column 1</td>");
            sb.AppendLine("<td>Table 1 - Row 2 - Column 2</td>");
            sb.AppendLine("<td>Table 1 - Row 2 - Column 3</td>");
            sb.AppendLine("</td>");
            sb.AppendLine("</tr>");
            sb.AppendLine("<tr>");
            sb.AppendLine("<td>Table 1 - Row 3 - Column 1</td>");
            sb.AppendLine("<td>Table 1 - Row 3 - Column 2</td>");
            sb.AppendLine("<td>Table 1 - Row 3 - Column 3</td>");
            sb.AppendLine("</td>");
            sb.AppendLine("</tr>");
            sb.AppendLine("</table>");

            // Вторая таблица (без заголовка)
            sb.AppendLine("<table>");
            sb.AppendLine("<tr>");
            sb.AppendLine("<td>Table 2 - Row 1 - Column 1</td>");
            sb.AppendLine("<td>Table 2 - Row 1 - Column 2</td>");
            sb.AppendLine("<td>Table 2 - Row 1 - Column 3</td>");
            sb.AppendLine("</td>");
            sb.AppendLine("</tr>");
            sb.AppendLine("<tr>");
            sb.AppendLine("<td>Table 2 - Row 2 - Column 1</td>");
            sb.AppendLine("<td>Table 2 - Row 2 - Column 2</td>");
            sb.AppendLine("<td>Table 2 - Row 2 - Column 3</td>");
            sb.AppendLine("</td>");
            sb.AppendLine("</tr>");
            sb.AppendLine("<tr>");
            sb.AppendLine("<td>Table 2 - Row 3 - Column 1</td>");
            sb.AppendLine("<td>Table 2 - Row 3 - Column 2</td>");
            sb.AppendLine("<td>Table 2 - Row 3 - Column 3</td>");
            sb.AppendLine("</td>");
            sb.AppendLine("</tr>");
            sb.AppendLine("</table>");

            sb.AppendLine("</body>");
            sb.AppendLine("</html>");

            return sb.ToString();
        }

        public DataSet ConvertHTMLTablesToDataSet(String HTML)
        {
            // Локальные сылки
            DataSet ds = new DataSet();
            DataTable dt;
            DataRow dr;
            // DataColumn dc;

            bool HeadersExist = false;  // Флаг заголовка таблицы
            int iCurrentColumn = 0;     // Счетчик столбцов
            int iCurrentRow = 0;        // Счетчик строк

            // Регулярные выражения
            String TableExpression = "<table[^>]*>(.*?)</table>";
            String HeaderExpression = "<th[^>]*>(.*?)</th>";
            String RowExpression = "<tr[^>]*>(.*?)</tr>";
            String ColumnExpression = "<td[^>]*>(.*?)</td>";
            RegexOptions options = RegexOptions.Multiline |
                                   RegexOptions.Singleline |
                                   RegexOptions.IgnoreCase;

            // Заполняем коллекцию соответствий для всех таблиц HTML
            MatchCollection Tables = Regex.Matches(HTML, TableExpression, options);

            // Проходим по всем таблицам 
            foreach (Match Table in Tables)
            {
                // Сбрасываем счетчик строки и флаг заголовка
                HeadersExist = false;
                iCurrentRow = 0;

                // Создаем объект новой таблицы и наполняем его
                dt = new DataTable();

                /* Создаем соответствующее количество столбцов 
                 * для текущей таблицы (используем заголовки, 
                 * если они существуют, иначе используем 
                 * заданные по умолчанию названия)                
                 */
                if (Table.Value.Contains("<th"))
                {
                    HeadersExist = true;// Таблица содержит заголовок
                    // Заполняем коллекцию соответствий для всех <th> в таблице
                    MatchCollection Headers = Regex.Matches(
                        Table.Value, HeaderExpression, options);

                    // Добавляем столбцы с именами из строки заголовков текущей таблицы
                    foreach (Match Header in Headers)
                    {
                        dt.Columns.Add(Header.Groups[1].ToString());
                    }
                }
                else
                {
                    Match tab = Regex.Matches(Table.Value, TableExpression, options)[0];
                    Match row = Regex.Matches(tab.ToString(), RowExpression, options)[0];
                    int count = Regex.Matches(row.ToString(), ColumnExpression, options).Count;

                    // Строки заголовков нет, добавляем дежурные имена
                    for (int iColumns = 0; iColumns < count; iColumns++)
                        dt.Columns.Add("Column" + iColumns);
                }

                // Извлекаем коллекцию строк текущей таблицы
                MatchCollection Rows = Regex.Matches(Table.Value, RowExpression, options);

                // Добавляем строки в объект DataRow
                foreach (Match Row in Rows)
                {
                    // Игнорируем строку заголовка
                    if (iCurrentRow != 0 || HeadersExist != true)
                    {
                        dr = dt.NewRow();
                        iCurrentColumn = 0;
                        // Извлекаем коллекцию столбцов текущей строки
                        MatchCollection Columns = Regex.Matches(Row.Value, ColumnExpression, options);
                        foreach (Match Column in Columns)
                        {
                            dr[iCurrentColumn] = Column.Groups[1].ToString();
                            iCurrentColumn++;
                        }

                        dt.Rows.Add(dr);
                    }

                    iCurrentRow++;
                }

                ds.Tables.Add(dt);
            }

            return ds;
        }
    }
}