﻿
using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using MyClock; // Пространство имен таймера в библиотеке WpfControlLibrary

namespace WpfControlLibrary
{
    public partial class Clock : UserControl
    {
        public Clock()
        {
            InitializeComponent();

            // Извлекаем объект из коллекции ресурсов
            clock = this.Resources["clock"] as DigitalClock;
        }
        DigitalClock clock; // Ссылка на экземпляр из ресурсов

        // Поле маршрутизированного события
        public static readonly RoutedEvent StopClockEvent;

        // Статический конструктор
        static Clock()
        {
            // Регистрация маршрутизированного события
            StopClockEvent = EventManager.RegisterRoutedEvent(
                "StopClock", RoutingStrategy.Bubble,
                typeof(RoutedEventHandler), typeof(Clock));
        }

        // Контейнер для подписки на маршрутизированное событие
        public event RoutedEventHandler StopClock
        {
            add { AddHandler(StopClockEvent, value); }
            remove { RemoveHandler(StopClockEvent, value); }
        }

        // Возбуждение маршрутизированного события через обработчик простого события
        private void DigitalClock_StopDigitalClock(object sender, EventArgs e)
        {
            this.RaiseEvent(new RoutedEventArgs(Clock.StopClockEvent));
        }

        // Функции доступа для управления таймером из клиента
        public void Start()
        {
            clock.Start();
        }
        public void Restart()
        {
            clock.Restart();
        }
        public void StopResult()
        {
            clock.StopResult();
        }
        public void Stop()
        {
            clock.Stop();
        }
    }
}